//--------------------------------------------------------------------
// $Id: ChildFrm.cpp 4718 2007-09-15 02:34:13Z cjm $
//--------------------------------------------------------------------
//
//   GUEmap
//   Copyright 1996-2007 by Christopher J. Madsen
//
//   This program is free software; you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation; either version 2 of the License, or
//   (at your option) any later version.
//
//   This program is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License along
//   with this program; if not, write to the Free Software Foundation, Inc.,
//   51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//
//   ChildFrm.cpp : Implementation of the CChildFrame class
//
//--------------------------------------------------------------------

#include "StdAfx.hpp"
#include "GUEmap.hpp"

#include "ChildFrm.hpp"
#include "MapDoc.hpp"
#include "MapView.hpp"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CChildFrame

IMPLEMENT_DYNCREATE(CChildFrame, CMDIChildWnd)

BEGIN_MESSAGE_MAP(CChildFrame, CMDIChildWnd)
	//{{AFX_MSG_MAP(CChildFrame)
	// NOTE - the ClassWizard will add and remove mapping macros here.
	//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG_MAP
END_MESSAGE_MAP();

/////////////////////////////////////////////////////////////////////////////
// CChildFrame construction/destruction

CChildFrame::CChildFrame()
{
	// TODO: add member initialization code here

}

CChildFrame::~CChildFrame()
{
}

/////////////////////////////////////////////////////////////////////////////
// CChildFrame diagnostics

#ifdef _DEBUG
void CChildFrame::AssertValid() const
{
	CMDIChildWnd::AssertValid();
}

void CChildFrame::Dump(CDumpContext& dc) const
{
	CMDIChildWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CChildFrame message handlers
//--------------------------------------------------------------------
// Activate the window:
//
// If this is the first child window, then maximize it.

void CChildFrame::ActivateFrame(int nCmdShow)
{
  if(GetMDIFrame()->MDIGetActive())
    CMDIChildWnd::ActivateFrame(nCmdShow);         // Not the first window
  else
    CMDIChildWnd::ActivateFrame(SW_SHOWMAXIMIZED); // Open first wnd maximized
} // end CChildFrame::ActivateFrame

//--------------------------------------------------------------------
// Update the window title:
//
// Based on CMDIChildWnd::OnUpdateFrameTitle from WINMDI.CPP (MFC 4.21)
//
// Display the zoom factor (if not 100%).

void CChildFrame::OnUpdateFrameTitle(BOOL addToTitle)
{
  // update our parent window first
  GetMDIFrame()->OnUpdateFrameTitle(addToTitle);

  if (((GetStyle() & FWS_ADDTOTITLE) == 0) || !addToTitle)
    return;                     // leave child window alone!

  const CDocument*  doc = GetActiveDocument();
  const CMapView*  view = static_cast<CMapView*>(GetActiveView());
  if (!doc || !view) return;
  ASSERT(view->IsKindOf(RUNTIME_CLASS(CMapView)));
  const int  zoom = view->getZoom();
  if ((m_nWindow > 0) || (zoom != 100)) {
    String  s;
    TCHAR   n[17];
    Strcpy(s, doc->GetTitle());
    if (m_nWindow > 0) {
      s += _T(':');
      _itot(m_nWindow, n, 10);
      s += n;
    }
    if (zoom != 100) {
      s += _T(" at ");
      _itot(zoom, n, 10);
      s += n;
      s += _T('%');
    }
    ::SetWindowText(m_hWnd, s.c_str());
  } else
    ::SetWindowText(m_hWnd, doc->GetTitle());
} // end CChildFrame::OnUpdateFrameTitle

/////////////////////////////////////////////////////////////////////////////
// Local Variables:
// compile-command: "nmake -f GUEmap.mak"
// End:
