//--------------------------------------------------------------------
// $Id: FindDlg.hpp 4718 2007-09-15 02:34:13Z cjm $
//--------------------------------------------------------------------
//
//   GUEmap
//   Copyright 1996-2007 by Christopher J. Madsen
//
//   This program is free software; you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation; either version 2 of the License, or
//   (at your option) any later version.
//
//   This program is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License along
//   with this program; if not, write to the Free Software Foundation, Inc.,
//   51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//
//   Interface of the CFindDlg class
//
//--------------------------------------------------------------------

#ifndef __FINDDLG_HPP
#define __FINDDLG_HPP

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

/////////////////////////////////////////////////////////////////////////////
// CFindDlg dialog

class CFindDlg : public CDialog
{
  // Construction
 public:
  CFindDlg(CCommentDlg* theCommentDlg, CWnd* pParent = NULL);
  BOOL Create() { return CDialog::Create(IDD); };

  // Dialog Data
	//{{AFX_DATA(CFindDlg)
	enum { IDD = IDD_FIND };
	CString	what;
	BOOL	matchCase;
	int		searchIn;
	//}}AFX_DATA

  CComboBox  history;
  CRect  pos;

  // Overrides
  // ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CFindDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

  // Implementation
 protected:

  CCommentDlg *const  commentDlg;
  CMapView*  mapView;
  int        whichRoom;
  StrIdx     match;

  int skip[UCHAR_MAX+1];
  int skip2;

  void    bmh_init(bool ignoreCase);
  StrIdx  bmh_search(const String& s);
  StrIdx  bmhi_search(const String& s);

  bool updatePattern();

  // Generated message map functions
	//{{AFX_MSG(CFindDlg)
	afx_msg void OnEditComments();
	afx_msg void OnFindNext();
	virtual BOOL OnInitDialog();
	virtual void OnCancel();
	//}}AFX_MSG
  DECLARE_MESSAGE_MAP();
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // not __FINDDLG_HPP
