//--------------------------------------------------------------------
// $Id: MainFrm.hpp 4718 2007-09-15 02:34:13Z cjm $
//--------------------------------------------------------------------
//
//   GUEmap
//   Copyright 1997-2007 by Christopher J. Madsen
//
//   This program is free software; you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation; either version 2 of the License, or
//   (at your option) any later version.
//
//   This program is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License along
//   with this program; if not, write to the Free Software Foundation, Inc.,
//   51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//
//   MainFrm.h : interface of the CMainFrame class
//
//--------------------------------------------------------------------

class CMainFrame : public CMDIFrameWnd
{
  DECLARE_DYNAMIC(CMainFrame);
 public:
  CMainFrame();

  // Attributes
 public:
  CDialogBar  wndNavBar;

  // Operations
 public:

  void setStatusBar(LPCTSTR text) {m_wndStatusBar.SetWindowText(text);};

  // Overrides
  // ClassWizard generated virtual function overrides
  //{{AFX_VIRTUAL(CMainFrame)
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
  //}}AFX_VIRTUAL

  // Implementation
 public:
  virtual ~CMainFrame();

  void  DockControlBarLeftOf(CControlBar* Bar,CControlBar* LeftOf);

#ifdef _DEBUG
  virtual void AssertValid() const;
  virtual void Dump(CDumpContext& dc) const;
#endif

 protected:  // control bar embedded members
  CStatusBar  m_wndStatusBar;
  CToolBar    m_wndToolBar;

  // Generated message map functions
 protected:
	//{{AFX_MSG(CMainFrame)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnActivateApp(BOOL bActive, HTASK hTask);
	afx_msg void OnDestroy();
	//}}AFX_MSG
  DECLARE_MESSAGE_MAP();
};

/////////////////////////////////////////////////////////////////////////////
// Local Variables:
// mode: c++
// compile-command: "nmake -f GUEmap.mak"
// End:
