//--------------------------------------------------------------------
// $Id: StdAfx.hpp 4720 2007-09-15 04:01:15Z cjm $
//--------------------------------------------------------------------
//
//   GUEmap
//   Copyright 1996-2007 by Christopher J. Madsen
//
//   This program is free software; you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation; either version 2 of the License, or
//   (at your option) any later version.
//
//   This program is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License along
//   with this program; if not, write to the Free Software Foundation, Inc.,
//   51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//
//   Include file for standard system include files,
//   or project specific include files that are used frequently,
//   but are changed infrequently
//
//--------------------------------------------------------------------

#define VC_EXTRALEAN	    // Exclude rarely-used stuff from Windows headers

#include <afxwin.h>         // MFC core and standard components
#include <afxext.h>         // MFC extensions
#ifndef _AFX_NO_AFXCMN_SUPPORT
#include <afxcmn.h>         // MFC support for Windows 95 Common Controls
#endif // _AFX_NO_AFXCMN_SUPPORT

#include <algorithm>
#include <string>
#include <vector>
using namespace std;

typedef string  String;

typedef String::size_type      StrIdx;
typedef String::iterator       StrItr;
typedef String::const_iterator StrConstItr;

typedef vector<BYTE>  ByteVec;
typedef ByteVec::iterator       ByteItr;
typedef ByteVec::const_iterator ByteConstItr;

typedef vector<WORD>  WordVec;

typedef ByteVec::size_type  VecSize;
#include "Array.hpp"
#include "CJM_algorithm.hpp"

inline void Strcpy(CString& cs, const String& s)
{
  strcpy(cs.GetBuffer(int(s.length()+1)), s.c_str());
  cs.ReleaseBuffer(int(s.length()));
}

inline void Strcpy(String& s, const CString& cs)
{
  s.assign(LPCTSTR(cs), StrIdx(cs.GetLength()));
}

#ifdef CJM_DEBUG
#define CJM_MEMCHECK { if (!AfxCheckMemory()) AfxDebugBreak(); }
#else
#define CJM_MEMCHECK ((void)0)
#endif

#pragma warning(disable: 4800)  // forcing int to bool

/////////////////////////////////////////////////////////////////////////////
// Local Variables:
// mode: c++
// compile-command: "nmake -f GUEmap.mak"
// End:
